<!--suppress CheckEmptyScriptTag -->
<style scoped>
    .media-wrapper {
        font-size: 1rem;
        background-color: #f5f5f5;
    }
    .media-wrapper.mobile {
        font-size: 0.9rem;
    }

    .pixabay-attribution img {
        height: auto;
        max-width: 40px;
        float: right;
    }
    /* Controls
    ---------------------------------------------------------------------- */

    .controls {
        color: #fff;
        padding: 1rem;
        background: #333;
        text-align: center;
    }
    .controls .button {
        margin: 3px;
    }
    .controls.error {
        color: #ff3860;
    }
    .controls.loading {
        color: #fff;
    }

    .mixitup-control-active {
        background-color: #2366d1;
    }
    .mixitup-control-active:hover {
        background-color: #2366d1;
    }

    /* Container
    ---------------------------------------------------------------------- */

    .container {
        padding: 1rem;
        text-align: justify;
    }

    .container:after {
        content: '';
        display: inline-block;
        width: 100%;
    }

    /* Target Elements
    ---------------------------------------------------------------------- */

    .mix {
        display: inline-block;
        vertical-align: middle;
        background: #333;
        border-radius: 5px;
        position: relative;
        margin: 3px;
        overflow: hidden;
    }
    .mix a div {
        height: 100%;
        width: 100%;
        background-position: center;
        background-repeat: no-repeat;
    }

    .mix:hover {
        cursor: pointer;
    }

    .mix:hover .iss-image-tag {
        display: inline-block;
        position: absolute;
        bottom: 0;
        width: 100%;
        text-align: center;
        overflow: hidden;
    }
    .mix:hover .iss-image-tag .tag {
        margin: 0 3px;
    }

    .mix:hover .city {
        position: absolute;
        bottom: 0;
        left: -3px;
        width: 100%;
    }

    /* Grid Breakpoints
    ---------------------------------------------------------------------- */

    /* 2 Columns */

    .mix {
        width: calc(100%/2 - (((2 - 1) * 1rem) / 2));
    }

    /* 3 Columns */

    @media screen and (min-width: 541px) {
        .mix {
            width: calc(100%/3 - (((3 - 1) * 1rem) / 3));
        }
    }

    /* 4 Columns */

    @media screen and (min-width: 961px) {
        .mix {
            width: calc(100%/4 - (((4 - 1) * 1rem) / 4));
        }
    }

    /* 5 Columns */

    @media screen and (min-width: 1281px) {
        .mix {
            width: calc(100%/5 - (((5 - 1) * 1rem) / 5));
        }
    }

</style>

<template>
    <div :id="id" :class="mediaWrapperClasses">
        <div v-show="show.error.enabled" class="controls error" v-html="errorMessage"></div>
        <div v-show="show.loading.enabled" class="controls loading" v-html="loadingMessage"></div>
        <div v-show="show.emptySet.enabled" class="controls loading" v-html="emptySetMessage"></div>
        <div v-show="show.media.enabled" class="controls">
            <button type="button" class="button is-primary is-rounded" data-filter="all">All</button>
            <button v-for="tag in tags"
                    type="button" class="button is-primary is-rounded"
                    :data-filter="'.' + tag + '-tag'" v-html="tag"></button>
        </div>
        <div v-show="show.media.enabled"class="container is-fluid">
            <div v-for="media in coordinates.data"
                 :class="getItemClasses(media)" :style="{ height: wrapHeight + 'px' }">
                <a :href="media.large" target="_blank">
                    <div :style="{ backgroundImage: 'url(' + media.medium + ')' }"></div>
                    <div class="iss-image-tag">
                        <span v-for="tag in getTags(media)"
                              class="tag is-primary" v-html="tag"></span>
                        <span class="city tag is-dark"
                              v-html="`${media.city.name} (${media.country.name} - ${media.continent.id})`"></span>
                    </div>
                </a>
            </div>
        </div>
        <div class="pixabay-attribution">
            <a href="https://pixabay.com" target="_blank">
                <img src="https://pixabay.com/static/img/logo_square.png" alt="Images powered by Pixabay">
            </a>
        </div>
    </div>
</template>

<script>
    import mixitup from 'mixitup';
    // noinspection JSUnusedGlobalSymbols
    export default {
        name: "MediaUi",

        created: function () {
            this.$root.$on('update-media', this.getMedia);
        },

        data: function() {
            return {
                id: 'media', // Component ID
                el: null, // The element that contains the mixitup plugin
                width: 0, // Viewport width
                wrapHeight: 200, // Height for media wrapper
                mixer: null, // mixitup object
                reinstantiating: false, // Used to avoid multiple reinstantiations of MixItUp
                show: { // What are we currently showing? Only one should be enabled
                    loading: {
                        enabled: true,
                        key: 'start' // in the messages section to use for content
                    },
                    error: {
                        enabled: false,
                        key: 'generic' // in the messages section to use for content
                    },
                    emptySet: {
                        enabled: false,
                        key: 'empty' // in the messages section to use for content
                    },
                    media: {
                        enabled: false,
                        key: 'start' // in the messages section to use for content
                    }
                },
                messages: {
                    error: { // Collection of content to show for error state
                        generic: { // generic key
                            icon: {
                                before: '<i class="fa fa-exclamation-triangle" style="padding: 0 20px"></i>',
                                after: '<i class="fa fa-exclamation-triangle" style="padding: 0 20px"></i>'
                            },
                            text: 'There was an error procuring the media, please try again later'
                        }
                    },
                    loading: { // Collection of content to show for loading state
                        start: { // Initial loading message
                            icon: {
                                before: '<i class="fa fa-cogs" style="padding: 0 20px"></i>'
                            },
                            text: 'Starting up ...'
                        },
                        fetch: { // Content to show when fetching content
                            icon: {
                                before: '<i class="fas fa-spinner fa-pulse" style="padding: 0 20px"></i>',
                                after: '<i class="fa fa-cloud-download-alt" style="padding: 0 20px"></i>'
                            },
                            text: 'Fetching images'
                        }
                    },
                    emptySet: {
                        empty: { // Initial loading message
                            icon: {
                                before: '<i class="fa fa-robot" style="padding: 0 20px"></i>'
                            },
                            text: 'We couldn\'t find any images around the selected position. Please try somewhere else'
                        },
                    }
                },
                coordinates: {
                    lat: null,
                    lng: null,
                    data: [] // Store of the procured data for the current coordinates
                },
                latestScreenState: 'desktop' // Used to determine change of mode
            }
        },

        computed: {
            /**
             * Determine classes for media wrapper
             * @return string
             */
            mediaWrapperClasses: function () {
                if (this.width <= 768) {
                    return 'media-wrapper mobile'
                }
                return 'media-wrapper'
            },
            /**
             * Get the currently set error message
             * @return string
             */
            errorMessage: function () {
                let key = this.show.error.key,
                    icons = this.getIcons(this.messages.error[key]);

                return icons.before + this.messages.error[key].text + icons.after;
            },
            /**
             * Get the currently set loading message
             * @return string
             */
            loadingMessage: function () {
                let key = this.show.loading.key,
                    icons = this.getIcons(this.messages.loading[key]);

                return icons.before + this.messages.loading[key].text + icons.after;
            },
            /**
             * Get the currently set empty set message
             * @return string
             */
            emptySetMessage: function () {
                let key = this.show.emptySet.key,
                    icons = this.getIcons(this.messages.emptySet[key]);

                return icons.before + this.messages.emptySet[key].text + icons.after;
            },
            /**
             * Currently available tags: will return the 15 most popular tags (5 if it's
             * a mobile interface)
             * @return Array
             */
            tags: function () {
                let prevScreenState = this.latestScreenState,
                    reinstantiateMixItUp,
                    tags = [],
                    max = 10;

                if (this.width <= 768) {
                    this.latestScreenState = 'mobile';
                    max = 5;
                } else {
                    this.latestScreenState = 'desktop';
                }
                reinstantiateMixItUp = prevScreenState !== this.latestScreenState;
                if (this.coordinates.data.length === 0) {
                    return tags;
                }

                // Let's determine the situation
                let tempTags = {};

                this.coordinates.data.forEach((item) => {
                    let itemTags = this.getTags(item);

                    for (let i = 0; i < itemTags.length; i++) {
                        if (!tempTags[itemTags[i]]) {
                            tempTags[itemTags[i]] = 1;
                            continue;
                        }
                        tempTags[itemTags[i]]++;
                    }
                });

                // Structure the data in a sortable fashion
                let sortableTags = [];

                for (let tag in tempTags) {
                    if (!tempTags.hasOwnProperty(tag)) {
                        continue;
                    }
                    sortableTags.push([tag, tempTags[tag]]);
                }
                // Let's sort it
                sortableTags.sort(function(a, b) {
                    return b[1] - a[1];
                });

                // Extract final array
                if (sortableTags.length < max) {
                    max = sortableTags.length;
                }
                for (let i = 0; i < max; i++) {
                    tags.push(sortableTags[i][0]);
                }

                if (reinstantiateMixItUp) {
                    this.reinstantiateMixItUp(700);
                }

                return tags;
            }
        },

        methods: {
            /**
             * Determine the icons to use before and after a message's content
             * @param message - The message object
             * @return Object
             */
            getIcons: function (message) {
                let icons = {
                    before: '',
                    after: ''
                };

                if (!message.icon) {
                    return icons;
                }
                if (message.icon.before) {
                    icons.before = message.icon.before;
                }
                if (message.icon.after) {
                    icons.after = message.icon.after;
                }

                return icons;
            },

            /**
             * Set Media to loading
             * @param key - specify a key to determine the text to show
             */
            showLoading: function (key) {
                if (key) {
                    this.show.loading.key = key;
                }
                this.show.loading.enabled = true;
                this.show.error.enabled = false;
                this.show.media.enabled = false;
                this.show.emptySet.enabled = false;
            },
            /**
             * Set Media to viewable
             * @param key - specify a key to determine the text to show
             */
            showMedia: function (key) {
                if (key) {
                    this.show.media.key = key;
                }
                this.show.loading.enabled = false;
                this.show.error.enabled = false;
                this.show.media.enabled = true;
                this.show.emptySet.enabled = false;
                this.reinstantiateMixItUp();
            },
            /**
             * Set Media to error
             * @param key - specify a key to determine the text to show
             */
            showError: function (key) {
                if (key) {
                    this.show.error.key = key;
                }
                this.show.loading.enabled = false;
                this.show.error.enabled = true;
                this.show.media.enabled = false;
                this.show.emptySet.enabled = false;
            },
            /**
             * Set Media to error
             * @param key - specify a key to determine the text to show
             */
            showEmptySet: function (key) {
                if (key) {
                    this.show.emptySet.key = key;
                }
                this.show.loading.enabled = false;
                this.show.error.enabled = false;
                this.show.media.enabled = false;
                this.show.emptySet.enabled = true;
            },

            /**
             * Reinstantiate MixItUp (do this when the source data has changed)
             * @param wait - milliseconds to wait prior to reinstantiating (default is 500)
             */
            reinstantiateMixItUp: function (wait) {
                if (this.reinstantiating) {
                    return;
                }
                this.reinstantiating = true;
                if (!wait) {
                    wait = 500;
                }
                setTimeout(() => {
                    this.mixer.destroy();
                    this.el = document.querySelector('#' + this.id + ' .container');
                    this.mixer = mixitup(this.el);
                    this.updateMaxMediaHeight();
                    this.reinstantiating = false;
                }, wait);
            },

            /**
             * Set up the required data in order to show procured content
             */
            showMediaContent: function () {
                if (this.coordinates.data.length === 0) {
                    this.showEmptySet();
                    return;
                }

                this.showMedia();
            },
            /**
             * Set up the required data in order to show procured content
             */
            getItemClasses: function (item) {
                let classes = 'mix',
                    itemTags = this.getTags(item);

                itemTags.forEach((tag) => {
                    classes += ' ' + tag + '-tag';
                });

                return classes;
            },
            /**
             * Get the tags stored in an item
             * @return Array
             */
            getTags: function (item) {
                let tags = [];

                if (!item.tags) {
                    return tags;
                }
                for (let i = 0; i < item.tags.length; i++) {
                    if (tags.indexOf(item.tags[i]) !== -1) {
                        continue;
                    }
                    let tag = item.tags[i].toString().trim().toLowerCase();

                    tags.push(tag.replace(/\s+/g, '-'));
                }

                return tags;
            },

            /**
             * Get images for the supplied coordinates
             * @param coordinates - Object containing lat key and lng key
             */
            getMedia: function (coordinates) {
                let url = issEnvVars.urls.media.get,
                    urlParam;

                if (typeof coordinates.lat === 'undefined') {
                    return;
                }
                if (typeof coordinates.lng === 'undefined') {
                    return;
                }

                this.coordinates.lat = coordinates.lat;
                this.coordinates.lng = coordinates.lng;
                this.showLoading('fetch');

                urlParam = this.coordinates.lat.toString() + '_';
                urlParam += this.coordinates.lng.toString();
                if (url.substring(url.length - 1) !== '/') {
                    url += '/';
                }
                url += urlParam;

                // noinspection ES6ModulesDependencies
                axios.get(url)
                    .then((response) => {
                        if (!response.data) {
                            // Set media to no media
                            this.coordinates.data = [];
                            this.showError();
                            return;
                        }
                        this.coordinates.data = response.data;
                        this.showMediaContent();
                    })
                    .catch((error) => {
                        this.showError();
                        console.log(error);
                    });
            },

            /**
             * On screen resize, we want to update the image wrapper height.
             */
            updateMaxMediaHeight: function () {
                let images = document.getElementsByClassName("mix");

                if (images.length === 0) {
                    this.wrapHeight = 200;
                    return;
                }
                this.wrapHeight = images[0].offsetWidth * 0.75;
            }
        },

        mounted() {
            // We have an empty set of media by default
            this.coordinates.data = [];

            // Configure initial messaging and loading state.
            this.showLoading('start');

            // Assign the element for the mixitup plugin
            this.el = document.querySelector('#' + this.id + ' .container');

            // Instantiate mixitup
            this.mixer = mixitup(this.el);

            // Setup event listener for resize event
            this.width =
                Math.max(document.documentElement.clientWidth, window.innerWidth || 0);

            window.addEventListener('resize', () => {
                this.width =
                    Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
                // Set the max height attr for the images
                this.updateMaxMediaHeight();
            });
        }
    }
</script>